<template>
  <div class="filter-component">
    <h2>Search and Filter</h2>
    <div class="mb-2rem">
      <select v-model="mode">
        <option value="basic">Basic Search</option>
        <option value="extended">Extended Search</option>
      </select>
    </div>
    <div class="items" v-if="mode === 'basic'">
      <div>
        <label>Search</label>
        <input type="text" v-model="query" placeholder="Person, Domain or Subject" @keyup="checkForEnterKey"/>
      </div>
      <div>
        <label>Type</label>
        <div>
          <div>
            <input type="checkbox" name="type" value="Domain" v-model="types" id="optionDomain">
            <label for="optionDomain">Domain</label>
          </div>
          <div>
            <input type="checkbox" name="type" value="User" v-model="types" id="optionUser">
            <label for="optionUser">User</label>
          </div>
          <div>
            <input type="checkbox" name="type" value="Mail" v-model="types" id="optionMail">
            <label for="optionMail">Email</label>
          </div>
        </div>
      </div>
      <div v-if="types.includes('Mail')">
        <div class="mb-1rem">
          <label class="bold">Replies</label>
        </div>
        <input type="checkbox" v-model="includeReplyingMails" class="mr-1rem" id="replyingMails">
        <label class="normal" for="replyingMails">Include Replying Emails</label>
      </div>
      <div v-if="types.includes('Mail')">
        <label>Dates (Email)</label>
        <div class="mb-1rem">
          <input type="checkbox" v-model="useExponential" class="mr-1rem" id="useExponential">
          <label class="normal" for="useExponential">Use Exponential Steps</label>
        </div>
        <div v-if="!useExponential">
          <div class="date-holder mb-1rem">
            <input type="date" v-model="dateStart">
            <input type="date" v-model="dateEnd">
          </div>
          <VueSlider v-model="dateRange" :max="todayInDaysSince1970" :min="startInDaysSince1970" :enable-cross="false">
            <template v-slot:tooltip="{ value }">
              <div class="vue-slider-dot-tooltip-inner vue-slider-dot-tooltip-inner-top">
                <span class="vue-slider-dot-tooltip-text">{{ formatTooltipDates(value) }}</span>
              </div>
            </template>
          </VueSlider>
        </div>
        <div v-else>
          <div class="mb-1rem">
            <input type="date" v-model="dateStart">
          </div>
          <VueSlider v-model="exponentialRange" :max="10" :min="0" :enable-cross="false">
            <template v-slot:tooltip="{ value }">
              <div class="vue-slider-dot-tooltip-inner vue-slider-dot-tooltip-inner-top">
                <span class="vue-slider-dot-tooltip-text">{{ formatTooltipExponentialStep(value) }}</span>
              </div>
            </template>
          </VueSlider>
        </div>
      </div>
      <div>
        <label>Number of Results</label>
        <VueSlider v-model="limit" :min="10" :max="1500" :interval="10"></VueSlider>
      </div>
      <button @click="search">Search</button>
    </div>
    <div class="items" v-if="mode === 'extended'">
      <textarea rows="20" placeholder="Match (n) RETURN n LIMIT 10" v-model="cypherQuery"></textarea>
      <button @click="runCypher">Search</button>
    </div>
  </div>
</template>

<script lang="ts">
import {defineComponent} from "vue";
import VueSlider from "vue-slider-component";
import 'vue-slider-component/theme/default.css'
import {transformer} from "@/typescript/transformer";
import {api} from "@/typescript/api";
import dayjs from "dayjs";

export default defineComponent({
  components: {
    VueSlider
  },
  data: function () {
    return {
      mode: 'basic',
      query: '',
      cypherQuery: '',
      limit: 500,
      types: ['Domain', 'User', 'Mail'],
      includeReplyingMails: false,
      todayInDaysSince1970: Math.floor(Date.now() / 1000 / 60 / 60 / 24),
      startInDaysSince1970: Math.floor(Date.parse('2005-01-01') / 1000 / 60 / 60 / 24),
      dateStart: '2005-01-01',
      dateEnd: dayjs().format('YYYY-MM-DD'),
      useExponential: false,
      exponentialRange: 0,
    }
  },
  mounted() {
    this.emitLimit(this.limit)
    this.emitIncludeReplyingMails()
  },
  watch: {
    limit() {
      this.emitLimit(this.limit)
    },
    includeReplyingMails() {
      this.emitIncludeReplyingMails()
    },
    exponentialRange() {
      this.updateEndDateBasedOnExponential()
    },
    dateStart() {
      if (this.useExponential) {
        this.updateEndDateBasedOnExponential()
      }
    }
  },
  computed: {
    dateRange: {
      get() {
        return [
          Math.floor(Date.parse(this.dateStart) / 1000 / 60 / 60 / 24),
          Math.floor(Date.parse(this.dateEnd) / 1000 / 60 / 60 / 24),
        ] as number[]
      },
      set(val: number[]) {
        // convert seconds from 1970 to date
        this.dateStart = this.formatToDateTime(val[0], 'YYYY-MM-DD')
        this.dateEnd = this.formatToDateTime(val[1], 'YYYY-MM-DD')
      }
    }
  },
  methods: {
    /**
     * Check if the enter key was pressed and perform a search if so.
     *
     * @param event
     */
    checkForEnterKey(event: KeyboardEvent) {
      if (event.key === 'Enter') {
        this.search()
      }
    },

    /**
     * Perform a search
     */
    async search() {
      const data = transformer.api2graph(
          await api.query(`
          MATCH (n)
          WHERE
          (${this.types.map((type: string) => `n:${type}`).join(' OR ')})
          AND (toLower(n.name) CONTAINS '${this.query.toLowerCase()}' OR toLower(n.subject) CONTAINS '${this.query.toLowerCase()}' OR toLower(n.email) CONTAINS '${this.query.toLowerCase()}')
          AND ((n.date >= datetime('${this.formatToDateTime(this.dateRange[0])}') AND n.date <= datetime('${this.formatToDateTime(this.dateRange[1])}')) OR n.date IS NULL)
          ${this.includeReplyingMails ? '' : 'AND (n.replying_to_message_id IS NULL OR n.replying_to_message_id = \'NONE\')'}
          RETURN n
          LIMIT ${this.limit}
        `)
      )

      // emit event to parent component
      this.$emit('data', data)
    },

    /**
     * Run a cypher query directly
     */
    async runCypher() {
      const data = transformer.api2graph(
          await api.query(this.cypherQuery)
      )

      // emit event to parent component
      this.$emit('data', data)
    },

    /**
     * Format days since 1970 to a cypher compatible date in format YYYY-MM-DDTHH:mm:ss
     *
     * @param val
     * @param format
     */
    formatToDateTime(val: number, format: string = 'YYYY-MM-DDTHH:mm:ss') {
      const date = new Date(val * 1000 * 60 * 60 * 24)
      return dayjs(date).format(format)
    },

    /**
     * Format days since 1970 to a human-readable date
     * @param val
     */
    formatTooltipExponentialStep(val: number) {
      return [
        'this hour',
        '1 day',
        '1 week',
        '1 month',
        '3 months',
        '6 months',
        '1 year',
        '2 years',
        '3 years',
        '5 years',
        '10 years',
      ][val]
    },

    /**
     * Format days since 1970 to a human readable date
     *
     * @param val
     */
    formatTooltipDates(val: number) {
      const date = new Date(val * 1000 * 60 * 60 * 24)
      return dayjs(date).format('DD.MM.YYYY')
    },

    /**
     * Emits the node limit to the parent component.
     *
     * @param limit
     */
    emitLimit(limit: number) {
      this.$emit('limit', limit)
    },

    /**
     * Emits the reply filter to the parent component.
     */
    emitIncludeReplyingMails() {
      this.$emit('includeReplyingMails', this.includeReplyingMails)
    },

    /**
     * Update the end date based on the exponential range.
     */
    updateEndDateBasedOnExponential() {
      const durationInSeconds = [
        60 * 60,
        60 * 60 * 24,
        60 * 60 * 24 * 7,
        60 * 60 * 24 * 30,
        60 * 60 * 24 * 30 * 3,
        60 * 60 * 24 * 30 * 6,
        60 * 60 * 24 * 365,
        60 * 60 * 24 * 365 * 2,
        60 * 60 * 24 * 365 * 3,
        60 * 60 * 24 * 365 * 5,
        60 * 60 * 24 * 365 * 10,
      ][this.exponentialRange]
      const secondsFromStartDate = Math.floor(Date.parse(this.dateStart) / 1000)
      this.dateEnd = this.formatToDateTime((secondsFromStartDate + durationInSeconds) / 60 / 60 / 24, 'YYYY-MM-DD')
    }
  }
})
</script>

<style scoped lang="scss">
div.filter-component {
  height: 100vh;
  background: #ffffff;
  padding: 2rem;
  overflow-y: auto;
  overflow-x: hidden;

  label {
    &.normal {
      font-weight: normal !important;
    }

    &.bold {
      font-weight: bold;
    }
  }

  & > h2 {
    margin-bottom: 2rem;
  }

  & > div.items {

    & > div > label {
      display: inline-block;
      font-weight: bold;
      margin-bottom: 1rem;
    }

    & > * {
      margin-bottom: 2rem;
    }

    div.date-holder {
      display: flex;
      justify-content: space-between;
      align-items: center;
      margin-bottom: 1rem;

      input {
        padding: .85rem;
        width: 48%;
        font-size: .85rem;
      }
    }
  }
}
</style>

<style>
.vue-slider-process {
  background-color: var(--color-accent);
}

.vue-slider-dot-tooltip-inner {
  border-color: var(--color-accent);
  background-color: var(--color-accent);
}
</style>